#include <iostream>

#define X 100
#define G 300

int M[X][X];

int L[X];
int C[X];

int resultatL[X];
int resultatC[X];

int n ;

int lb()
  /* lb est la lower bound, n est la taille de la matrice */
{
   int sum1 = 0;   
   for (int j = 0; j < n; j ++)
	 { 
		if (L[j])
		  {
			 int min = G;
			 for (int k = 0; k < n ; k++)
			   if (C[k])
				   if (M[j][k] < min) min = M[j][k];
			 sum1 += min;
		  }				
	 }
   int sum2 = 0;
   for (int j = 0; j < n; j ++)
	 { 
		if (C[j])
		  {
			 int min = G;
			 for (int k = 0; k < n ; k++)
			   if (L[k])
				   if (M[k][j] < min) min = M[k][j];
			 sum2 += min;
		  }				
	 }
   return (sum2 > sum1) ? sum2 : sum1;      
}

int ub1(int i)
  /* i le nb qui reste  prendre */
{
  int k;
   
  if (i == 0) return 0;
   
   /* cherche la premiere ligne qui n'a pas de colonnes correspondante */
  for (k = 0; (k < n) && (!L[k]); ++k);
  /* on cherche la plus petite colonne correspondante */
  int j;      
  int ind = n+1;
  for (j = 0; (j <n); ++j)
	 { 
		if (C[j])
		  {
			 if (ind == (n+1)) ind = j;
			 if (M[k][j] < M[k][ind]) ind = j;
		  }		
	 }
  j=ind;
  C[j] = 0;
  L[k] = 0;
  int t1 = ub1(i-1) + M[k][j];
  C[j] = 1;
  L[k] = 1;
   
   return t1;
}


int ubb(int i)
  /* i le nb qui reste  prendre */
{
  int k;
   
  if (i == 0) return 0;
   
   /* cherche la premiere ligne qui n'a pas de colonnes correspondante */
  for (k = 0; (k < n) && (!C[k]); ++k);
  /* on cherche la plus petite colonne correspondante */
  int j;      
  int ind = n+1;
  for (j = 0; (j <n); ++j)
	 { 
		if (L[j])
		  {
			 if (ind == (n+1)) ind = j;
			 if (M[j][k] < M[ind][k]) ind = j;
		  }		
	 }
  j=ind;
  L[j] = 0;
  C[k] = 0;
  int t1 = ubb(i-1) + M[j][k];
  L[j] = 1;
  C[k] = 1;
   
   return t1;
}

int ub(int i)
{
   int x = ub1(i);
   int y = ubb(i);
   return (x > y) ? y : x;
}

int bb(int i, int mc, int cc)
{
   if (i == 0) return cc;
  int l = cc + lb();
   if (l >= mc) return mc;
   int u = cc + ub(i);
   
   if (l == u) return l;

   int k;

   /* cherche la premiere ligne qui n'a pas de colonnes correspondante */
  for (k = 0; (k < n) && (!L[k]); ++k);
         
  int j;

    
   for (j = 0; (j <n); ++j)
	 { 
		if (C[j])
		  {
			 L[k] = 0;			  
			 C[j] = 0;
			 int t = bb(i-1,mc,cc+M[k][j]);
			 L[k] = 1;
			 C[j] = 1;
			 if (t < mc) mc = t;
		  }		
	 }
 return mc;
}




int main()
{
   std::cin >> n;
   for (int j = 0 ; j < n ; j++)
	 for (int k = 0; k < n; k++)
	   std::cin >> M[j][k];
   
   for (int j = 0; j < n; ++j)
	 {
		L[j] = 1;
		C[j] = 1;
	 }
   
   std::cout << "Lower bound: " << lb() << std::endl;
   std::cout << "Upper bound: " << ub(n) << std::endl;
   std::cout << "Optimal: "<< bb(n, ub(n),0) << std::endl;
}
