#include <iostream>
#include <stdlib.h>
#include <stdio.h>

#define X 15
#define G 500

int M[X][X];

int L[X];
int C[X];

int resultatL[X];
int resultatC[X];

int n;

int pions[15][2];
int dis_ligne, dis_colonne;

/*void afficheM()
{
  for (int i=0;i<n;++i)
    {
      for (int j=0;j<n;++j)
	std::cout << M[i][j]<<' ';
      std::cout << std::endl;
    }
  std::cout << std::endl;
}*/

int lb()
  /* lb est la lower bound, n est la taille de la matrice */
{
   int sum1 = 0;   
   for (int j = 0; j < n; j ++)
	 { 
		if (L[j])
		  {
			 int min = G;
			 for (int k = 0; k < n ; k++)
			   if (C[k])
				   if (M[j][k] < min) min = M[j][k];
			 sum1 += min;
		  }				
	 }
   int sum2 = 0;
   for (int j = 0; j < n; j ++)
	 { 
		if (C[j])
		  {
			 int min = G;
			 for (int k = 0; k < n ; k++)
			   if (L[k])
				   if (M[k][j] < min) min = M[k][j];
			 sum2 += min;
		  }				
	 }
   return (sum2 > sum1) ? sum2 : sum1;      
}

int ub1(int i)
  /* i le nb qui reste  prendre */
{
  int k;
   
  if (i == 0) return 0;
   
   /* cherche la premiere ligne qui n'a pas de colonnes correspondante */
  for (k = 0; (k < n) && (!L[k]); ++k);
  /* on cherche la plus petite colonne correspondante */
  int j;      
  int ind = n+1;
  for (j = 0; (j <n); ++j)
	 { 
		if (C[j])
		  {
			 if (ind == (n+1)) ind = j;
			 if (M[k][j] < M[k][ind]) ind = j;
		  }		
	 }
  j=ind;
  C[j] = 0;
  L[k] = 0;
  int t1 = ub1(i-1) + M[k][j];
  C[j] = 1;
  L[k] = 1;
   
   return t1;
}


int ubb(int i)
  /* i le nb qui reste  prendre */
{
  int k;
   
  if (i == 0) return 0;
   
   /* cherche la premiere ligne qui n'a pas de colonnes correspondante */
  for (k = 0; (k < n) && (!C[k]); ++k);
  /* on cherche la plus petite colonne correspondante */
  int j;      
  int ind = n+1;
  for (j = 0; (j <n); ++j)
	 { 
		if (L[j])
		  {
			 if (ind == (n+1)) ind = j;
			 if (M[j][k] < M[ind][k]) ind = j;
		  }		
	 }
  j=ind;
  L[j] = 0;
  C[k] = 0;
  int t1 = ubb(i-1) + M[j][k];
  L[j] = 1;
  C[k] = 1;
   
   return t1;
}

int ub(int i)
{
   int x = ub1(i);
   int y = ubb(i);
   return (x > y) ? y : x;
}

int bb(int i, int mc, int cc)
{
   if (i == 0) return cc;
  int l = cc + lb();
   if (l >= mc) return mc;
   //int u = cc + ub(i);
   
   //   if (l == u) return l;

   int k;

   /* cherche la premiere ligne qui n'a pas de colonnes correspondante */
  for (k = 0; (k < n) && (!L[k]); ++k);
         
  int j;

    
   for (j = 0; (j <n); ++j)
	 { 
		if (C[j])
		  {
			 L[k] = 0;			  
			 C[j] = 0;
			 int t = bb(i-1,mc,cc+M[k][j]);
			 L[k] = 1;
			 C[j] = 1;
			 if (t < mc) mc = t;
		  }		
	 }
 return mc;
}

void initLC()
{
  for (int j = 0; j < n; ++j)
    {
      L[j] = 1;
      C[j] = 1;
    }
}

int distance(int x1, int y1, int x2, int y2, int v)
{
  switch(v)
    {
    case 0: return abs(x1-x2);
    case 1: return abs(y1-y2);
    default: return abs(x1-x2)+abs(y1-y2);
    }
}

int distance_lc(int i, int l) // l=0 : lignes ; l=1 : colonnes
{
  int sum=0;
  for (int j=0;j<n;++j)
    sum += abs(pions[j][l]-i);
  return sum;
}

int meilleure_ligne()
{
  int mini=G;
  int mligne=1;
  int t;
  for (int i=1;i<=n;++i)
    {
      t = distance_lc(i,0);
      if (t<mini)
	{
	  mini=t;
	  mligne=i;
	  dis_ligne=t;
	}
    }
  return mligne;
}

int meilleure_colonne()
{
  int mini=G;
  int mcol=1;
  int t;
  for (int i=1;i<=n;++i)
    {
      t = distance_lc(i,1);
      if (t<mini)
	{
	  mini=t;
	  mcol=i;
	  dis_colonne=t;
	}
    }
  return mcol;
}

int main()
{
  int meilleure_lc;
  int meilleur, courant;
  int nb_cas=0;

  std::cin >> n;

  while (n != 0)
    {
      meilleur = G;
      ++nb_cas;
      // lecture de l'entre
      for (int i=0; i<n; ++i)
	std::cin >> pions[i][0] >> pions[i][1];

      meilleure_lc=meilleure_ligne();
      initLC();
      // remplissage de M
      for (int k=0; k<n; ++k)
	for (int l=0;l<n;++l)
	  M[k][l] = distance(pions[k][0],pions[k][1],meilleure_lc,l+1,1);
      // meilleur couplage
      meilleur=ub(n);
      courant = bb(n, meilleur, 0)+dis_ligne;
      meilleur=courant;

      meilleure_lc=meilleure_colonne();
      initLC();
      // remplissage de M
      for (int k=0; k<n; ++k)
	for (int l=0;l<n;++l)
	  M[k][l] = distance(pions[k][0],pions[k][1],l+1,meilleure_lc,0);
      // meilleur couplage
      courant = bb(n, meilleur-dis_colonne, 0)+dis_colonne;
      if (courant < meilleur) meilleur=courant;

      // en diagonale
      // nord-est
      initLC();
      // remplissage de M
      for (int k=0; k<n; ++k)
	for (int l=0;l<n;++l)
	  M[k][l] = distance(pions[k][0],pions[k][1],n-l,l+1,2);
      // meilleur couplage
      courant = bb(n, meilleur, 0);
      if (courant < meilleur) meilleur=courant;

      // sud-ouest
      initLC();
      // remplissage de M
      for (int k=0; k<n; ++k)
	for (int l=0;l<n;++l)
	  M[k][l] = distance(pions[k][0],pions[k][1],l+1,l+1,2);
      // meilleur couplage
      courant = bb(n, meilleur, 0);
      if (courant < meilleur) meilleur=courant;

      // std::cout
      std::cout<<"Board "<<nb_cas<<": "<<meilleur<<" moves required.\n\n";
      // taille du nouveau cas
      std::cin >> n;
    }
}
